object ParallelCollectionExample extends App {
	def time(f : () => Unit) = {
		val t1 = System.currentTimeMillis()
		f()
		println("Elapsed: " + ((System.currentTimeMillis() - t1)/1.0e3));
	}

    // This is NOT the most efficient way to determine whether a number 
    // is prime!  It's just a simple example!
    def isPrime(x : Int) : Boolean = {
        for (i <- 2 until x) {
            if ((x % i) == 0) {
              return true
            }
        }
        return false
    }

    println("Running normal collection isPrime test")
    time(() => { (1 to 100000).filter(isPrime) } )

    println("Running parallel collection isPrime test")
    time(() => { (1 to 100000).par.filter(isPrime) } )
}
