/* vim: set sw=4 ts=4 expandtab: */
import akka.actor._
//import akka.actor.Actor
//import akka.actor.ActorRef
//import akka.actor.ActorSystem
//import akka.actor.Props

class Client(server : ActorRef)  extends Actor {
    def receive = {
        case "Start" => server ! "Ping"
        case "Pong" => {
            println(Thread.currentThread().getName() + ": Pong!")
            context.stop(server)
            context.stop(self)
            context.system.shutdown
        }
        case _ => println("Unknown message!")
    }
}

class Server extends Actor {
    def receive = {
        case "Ping" => {
            println(Thread.currentThread().getName() + ": Ping!")
            sender ! "Pong"
        }
        case _ => println("Unknown message!")
    }
}

object Main extends App {
    val system = ActorSystem("PingPong")
    val server = system.actorOf(Props[Server])
    val client = system.actorOf(Props(new Client(server)))
    client ! "Start"  // get the ball rolling
}
